'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isNan = require('babel-runtime/core-js/number/is-nan');

var _isNan2 = _interopRequireDefault(_isNan);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClearableInput = (function (_Component) {
  (0, _inherits3.default)(ClearableInput, _Component);

  function ClearableInput(props) {
    (0, _classCallCheck3.default)(this, ClearableInput);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ClearableInput).call(this));

    var value = undefined;
    'value' in props && (value = props.value);
    'defaultValue' in props && (value = props.defaultValue);
    _this.state = { value: value };
    return _this;
  }

  (0, _createClass3.default)(ClearableInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({ value: nextProps.value });
    }
  }, {
    key: 'handleClear',
    value: function handleClear(e) {
      e.stopPropagation();
      this.props.onClear && this.props.onClear();
      this.handleChange('');
    }
  }, {
    key: 'handleInput',
    value: function handleInput(e) {
      e.stopPropagation();
      this.handleChange(e.target.value);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({ value: value });
      this.props.onChange && this.props.onChange(value);
    }

    /**
     * @public
     * @name this.refs.clearableInput.focus
     * @description 同 HTMLInputElement.focus()
     */

  }, {
    key: 'focus',
    value: function focus() {
      this.refs.input.focus();
    }

    /**
     * @public
     * @name this.refs.clearableInput.select
     * @description 同 HTMLInputElement.select()
     */

  }, {
    key: 'select',
    value: function select() {
      this.refs.input.select();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var defaultValue = _props.defaultValue;
      var onChange = _props.onChange;
      var onClear = _props.onClear;
      var inputProps = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultValue', 'onChange', 'onClear']);
      var value = this.state.value;

      delete inputProps.value;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('bfd-clearable-input', className) },
        _react2.default.createElement(_Input2.default, (0, _extends3.default)({
          ref: 'input',
          value: value,
          onChange: this.handleInput.bind(this)
        }, inputProps)),
        (value || value === 0 || (0, _isNan2.default)(value)) && _react2.default.createElement(_Button2.default, {
          tabIndex: '-1',
          icon: 'remove',
          size: 'sm',
          transparent: true,
          className: 'bfd-clearable-input__clear',
          disabled: inputProps.disabled,
          onClick: this.handleClear.bind(this)
        })
      );
    }
  }]);
  return ClearableInput;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

ClearableInput.propTypes = {

  // 输入框的值
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 初始化输入框的值
  defaultValue: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 输入改变、清空后的回调，参数为当前输入框的值
  onChange: _react.PropTypes.func,

  // 清空后的回调
  onClear: _react.PropTypes.func,

  // 输入框尺寸
  size: _react.PropTypes.oneOf(['sm', 'lg']),

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // 同 input placeholder
  placeholder: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var value = _ref.value;
    var onChange = _ref.onChange;

    if (value && !onChange) {
      return new Error('You provided a `value` prop without an `onChange` handler');
    }
  }
};

exports.default = ClearableInput;