'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Checkbox = require('../Checkbox');

require('./main.css');

require('../table.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Rows = (function (_Component) {
  (0, _inherits3.default)(Rows, _Component);

  function Rows(props) {
    (0, _classCallCheck3.default)(this, Rows);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Rows).call(this, props));

    _this.column = {};
    _this.selectedRow = {};
    return _this;
  }

  (0, _createClass3.default)(Rows, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.column.primary = this.getPrimaryKey(this.props.column);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (this.props.rows !== nextProps.rows) {
        (function () {
          var selectRow = [];
          nextProps.rows.map(function (item) {
            if (_this2.column.primary) {
              if (_this2.column.primary && item.isSelect) {
                _this2.selectedRow[item[_this2.column.primary]] = item;
              }
              if (_this2.selectedRow[item[_this2.column.primary]]) {
                item.isSelect = true;
                selectRow.push(item);
                if (selectRow.length == nextProps.rows.length) {
                  _this2.props.onCheckboxSelectAll && _this2.props.onCheckboxSelectAll(true);
                }
              }
            }
          });
        })();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var rows = this.props.rows;
      var column = this.props.column;
      var currentPage = this.props.currentPage || 1;
      var pageSize = this.props.pageSize || 0;

      var noDataContent = this.props.noDataContent;

      return _react2.default.createElement(
        'tbody',
        null,
        rows.length > 0 ? rows.map(function (item, j) {
          if (_this3.column.primary) {
            if (item.isSelect) {
              _this3.selectedRow[item[_this3.column.primary]] = item;
            } else {
              delete _this3.selectedRow[item[_this3.column.primary]];
            }
          }

          var isSelect = item.isSelect || false;
          var isDisabled = item.disabled || false;
          var checkboxTd = _this3.props.onCheckboxSelect ? _react2.default.createElement(
            'td',
            null,
            _react2.default.createElement(_Checkbox.Checkbox, { disabled: isDisabled, checked: isSelect, onClick: _this3.handleCheckboxClick.bind(_this3), onChange: _this3.handleCheckboxChange.bind(_this3, item) })
          ) : null;
          return _react2.default.createElement(
            'tr',
            { key: j, onClick: _this3.handleRowClick.bind(_this3, item, j) },
            checkboxTd,
            column.map(function (columns, i) {
              for (var col in columns) {
                // 序号
                if (columns[col] === 'sequence') {
                  return _react2.default.createElement(
                    'td',
                    { key: String(i) + j },
                    (currentPage - 1) * pageSize + (j + 1)
                  );
                }
                // 操作
                if (columns[col] == 'operation') {
                  return _react2.default.createElement(
                    'td',
                    { key: String(i) + j },
                    columns['render'](item, _this3, j)
                  );
                }
                // 正常非字段编辑列
                if (columns[col] !== 'operation' && columns[col] !== 'sequence' && col == 'key') {
                  var style = { display: columns.hide == true ? 'none' : '' };
                  if (typeof columns['render'] === 'function') {
                    return _react2.default.createElement(
                      'td',
                      { style: style, key: String(i) + j },
                      columns['render'](item[columns[col]], item, j)
                    );
                  } else {
                    return _react2.default.createElement(
                      'td',
                      { style: style, key: String(i) + j },
                      item[columns[col]]
                    );
                  }
                }
              }
            })
          );
        }) : _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'td',
            { colSpan: '9' },
            noDataContent
          )
        )
      );
    }
  }, {
    key: 'getPrimaryKey',
    value: function getPrimaryKey(column) {
      var key = undefined;
      column.map(function (item) {
        if (item.primary === true) {
          key = item.key;
        }
      });
      return key;
    }
  }, {
    key: 'handleCheckboxClick',
    value: function handleCheckboxClick(event) {
      event.stopPropagation();
    }
  }, {
    key: 'handleCheckboxChange',
    value: function handleCheckboxChange(row) {
      var rowId = row[this.column.primary];
      row.isSelect = !row.isSelect;
      if (row.isSelect) {
        this.selectedRow[rowId] = row;
      } else {
        delete this.selectedRow[rowId];
      }

      var selectRow = [];
      this.props.rows.map(function (item) {
        if (item.isSelect) {
          selectRow.push(item);
        }
      });

      var selectedRow = [];
      for (var p in this.selectedRow) {
        selectedRow.push(this.selectedRow[p]);
      }

      this.setState({
        t: +new Date()
      });

      this.props.onSelect(row.isSelect, row, selectRow, selectedRow);
    }
  }, {
    key: 'handleRowClick',
    value: function handleRowClick() {
      var _props;

      this.props.onRowClick && (_props = this.props).onRowClick.apply(_props, arguments);
    }
  }]);
  return Rows;
})(_react.Component);

exports.default = Rows;