'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _shouldComponentUpdate = require('../../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Calendar = (function (_Component) {
  (0, _inherits3.default)(Calendar, _Component);

  function Calendar(props) {
    (0, _classCallCheck3.default)(this, Calendar);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Calendar).call(this));

    _this.shouldComponentUpdate = _shouldComponentUpdate2.default;

    _this.state = _this.getDateState(props.date);
    return _this;
  }

  (0, _createClass3.default)(Calendar, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'date' in nextProps && this.setState(this.getDateState(nextProps.date));
    }
  }, {
    key: 'getDateState',
    value: function getDateState(date) {
      var d = date ? new Date(date) : new Date();
      var year = d.getFullYear();
      var month = d.getMonth();
      var day = d.getDate();
      return {
        // 选中的年月日
        year: date ? year : null,
        month: date ? month : null,
        day: date ? day : null,
        // 切换后的年月
        currentYear: year,
        currentMonth: month
      };
    }

    // 切换年月

  }, {
    key: 'handleToggle',
    value: function handleToggle(change, type) {
      var d = new Date(this.state.currentYear, this.state.currentMonth);
      if (type === 'year') {
        d.setFullYear(d.getFullYear() + change);
        this.setState({
          currentYear: d.getFullYear()
        });
      } else {
        d.setMonth(d.getMonth() + change);
        this.setState({
          currentYear: d.getFullYear(),
          currentMonth: d.getMonth()
        });
      }
    }
  }, {
    key: 'handleDaySelect',
    value: function handleDaySelect(date) {
      var year = date.year;
      var month = date.month;
      var day = date.day;

      this.setState({
        year: year,
        month: month,
        day: day,
        currentYear: year,
        currentMonth: month
      });
      this.props.onSelect && this.props.onSelect(new Date(year, month, day).setHours(0, 0, 0, 0));
    }
  }, {
    key: 'getZeroTimestrap',
    value: function getZeroTimestrap(date) {
      return new Date(date).setHours(0, 0, 0, 0);
    }
  }, {
    key: 'disabledComparer',
    value: function disabledComparer() {
      var _props = this.props;
      var min = _props.min;
      var max = _props.max;

      var _min = min && this.getZeroTimestrap(min);
      var _max = max && this.getZeroTimestrap(max);
      if (_min || _max) {
        return function (date) {
          var timestrap = new Date(date.year, date.month, date.day).getTime();
          return timestrap < _min || timestrap > _max;
        };
      } else {
        return function () {
          return false;
        };
      }
    }

    // 样式高亮，是否是今天、开始、结束、区间内、当月外、日期范围外

  }, {
    key: 'getDateClassNames',
    value: function getDateClassNames(date, start, end) {
      var _classnames;

      var _state = this.state;
      var year = _state.year;
      var month = _state.month;
      var day = _state.day;

      var timestrap = new Date(date.year, date.month, date.day).getTime();
      var isStart = timestrap === start;
      var isEnd = timestrap === end;
      var prefix = 'bfd-calendar__day--';

      return (0, _classnames3.default)('bfd-calendar__day', (_classnames = {}, (0, _defineProperty3.default)(_classnames, prefix + 'today', timestrap === new Date().setHours(0, 0, 0, 0)), (0, _defineProperty3.default)(_classnames, prefix + 'exclude', date.notThisMonth), (0, _defineProperty3.default)(_classnames, prefix + 'start', isStart), (0, _defineProperty3.default)(_classnames, prefix + 'end', isEnd), (0, _defineProperty3.default)(_classnames, prefix + 'active', timestrap === new Date(year, month, day).getTime()), (0, _defineProperty3.default)(_classnames, prefix + 'inside', start && end ? timestrap > start && timestrap < end : false), _classnames));
    }

    // 当前月各天的时间状态

  }, {
    key: 'getDates',
    value: function getDates() {
      var _state2 = this.state;
      var currentYear = _state2.currentYear;
      var currentMonth = _state2.currentMonth;

      var dates = [];
      var d = undefined;

      // 上月
      d = new Date(currentYear, currentMonth, 1);
      var dayInWeek = d.getDay() || 7;
      if (dayInWeek > 1) {
        d.setDate(0);
        var lastMonthDaysCount = d.getDate();
        for (var i = dayInWeek - 1; i--;) {
          dates.push({
            year: d.getFullYear(),
            month: d.getMonth(),
            day: lastMonthDaysCount - i,
            notThisMonth: true
          });
        }
      }

      // 本月
      d = new Date(currentYear, currentMonth + 1, 0);
      var thisMonthDaysCount = d.getDate();
      for (var i = 0; i < thisMonthDaysCount; i++) {
        dates.push({
          year: d.getFullYear(),
          month: d.getMonth(),
          day: i + 1
        });
      }

      // 下月
      d = new Date(currentYear, currentMonth + 1, 1);
      var _len = dates.length;
      for (var i = 0, len = (_len <= 35 ? 35 : 42) - _len; i < len; i++) {
        dates.push({
          year: d.getFullYear(),
          month: d.getMonth(),
          day: i + 1,
          notThisMonth: true
        });
      }
      return dates;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var start = _props2.start;
      var end = _props2.end;
      var captionRender = _props2.captionRender;
      var weekDayNames = _props2.weekDayNames;

      var dates = this.getDates();
      var getComparerResult = this.disabledComparer();

      var _start = undefined,
          _end = undefined;
      start && (_start = new Date(start).setHours(0, 0, 0, 0) || 0);
      end && (_end = new Date(end).setHours(0, 0, 0, 0) || 0);

      return _react2.default.createElement(
        'div',
        { className: 'bfd-calendar' },
        _react2.default.createElement(
          'div',
          { className: 'bfd-calendar__header' },
          _react2.default.createElement(
            'div',
            { className: 'bfd-calendar__header-left' },
            _react2.default.createElement(_Button2.default, {
              size: 'sm',
              icon: 'angle-double-left',
              transparent: true,
              onClick: this.handleToggle.bind(this, -1, 'year')
            }),
            _react2.default.createElement(_Button2.default, {
              size: 'sm',
              icon: 'angle-left',
              transparent: true,
              onClick: this.handleToggle.bind(this, -1)
            })
          ),
          _react2.default.createElement(
            'span',
            { className: 'bfd-calendar__result' },
            captionRender(this.state)
          ),
          _react2.default.createElement(
            'div',
            { className: 'bfd-calendar__header-right' },
            _react2.default.createElement(_Button2.default, {
              size: 'sm',
              icon: 'angle-right',
              transparent: true,
              onClick: this.handleToggle.bind(this, 1)
            }),
            _react2.default.createElement(_Button2.default, {
              size: 'sm',
              icon: 'angle-double-right',
              transparent: true,
              onClick: this.handleToggle.bind(this, 1, 'year')
            })
          )
        ),
        _react2.default.createElement(
          'table',
          null,
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              weekDayNames.map(function (name, i) {
                return _react2.default.createElement(
                  'th',
                  { key: i },
                  name
                );
              })
            )
          ),
          _react2.default.createElement(
            'tbody',
            null,
            Array(dates.length / 7 + 1).join(0).split('').map(function (v, i) {
              return _react2.default.createElement(
                'tr',
                { key: i },
                weekDayNames.map(function (name, j) {
                  var index = i * 7 + j;
                  var date = dates[index];
                  return _react2.default.createElement(
                    'td',
                    { key: index },
                    _react2.default.createElement(
                      'button',
                      {
                        type: 'button',
                        disabled: getComparerResult(date),
                        className: _this2.getDateClassNames(date, _start, _end),
                        onClick: _this2.handleDaySelect.bind(_this2, date)
                      },
                      date.day
                    )
                  );
                })
              );
            })
          )
        )
      );
    }
  }]);
  return Calendar;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

Calendar.defaultProps = {
  weekDayNames: ['一', '二', '三', '四', '五', '六', '日'],
  captionRender: function captionRender(state) {
    return state.currentYear + '年 ' + (state.currentMonth + 1) + '月';
  }
};

var checkDateTime = _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]);

Calendar.propTypes = {
  date: checkDateTime,
  min: checkDateTime,
  max: checkDateTime,
  start: checkDateTime,
  end: checkDateTime,
  onSelect: _react.PropTypes.func,
  captionRender: _react.PropTypes.func,
  weekDayNames: _react.PropTypes.array
};

exports.default = Calendar;