'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _DatePicker = require('../DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var DateRange = (function (_Component) {
  (0, _inherits3.default)(DateRange, _Component);

  function DateRange(props) {
    (0, _classCallCheck3.default)(this, DateRange);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DateRange).call(this));

    _this.state = {
      start: props.defaultStart || props.start,
      end: props.defaultEnd || props.end
    };
    return _this;
  }

  (0, _createClass3.default)(DateRange, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'start' in nextProps && this.setState({ start: nextProps.start });
      'end' in nextProps && this.setState({ end: nextProps.end });
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(type, date) {
      var range = undefined;
      if (type === 'start') {
        this.setState({ start: date });
        range = [date, this.state.end];
      } else {
        this.setState({ end: date });
        range = [this.state.start, date];
      }
      this.props.onSelect && this.props.onSelect.apply(this, range);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state;
      var start = _state.start;
      var end = _state.end;
      var _props = this.props;
      var className = _props.className;
      var defaultStart = _props.defaultStart;
      var defaultEnd = _props.defaultEnd;
      var onSelect = _props.onSelect;
      var min = _props.min;
      var max = _props.max;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultStart', 'defaultEnd', 'onSelect', 'min', 'max']);

      delete other.start;
      delete other.end;

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-daterange', className) }, other),
        _react2.default.createElement(_DatePicker2.default, {
          date: start,
          min: min,
          max: end,
          start: start,
          end: end,
          onSelect: this.handleSelect.bind(this, 'start')
        }),
        _react2.default.createElement(
          'span',
          { className: 'bfd-daterange__seperator' },
          '~'
        ),
        _react2.default.createElement(_DatePicker2.default, {
          date: end,
          min: start,
          max: max,
          start: start,
          end: end,
          onSelect: this.handleSelect.bind(this, 'end')
        })
      );
    }
  }]);
  return DateRange;
})(_react.Component);

DateRange.propTypes = {

  // 指定开始日期
  start: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 初始化指定的开始日期（不可控）
  defaultStart: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 指定结束日期
  end: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 初始化指定的结束日期（不可控）
  defaultEnd: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 日期选择后的回调，参数分别为开始、结束时间
  onSelect: _react.PropTypes.func,

  // 可选日期范围最小值
  min: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 可选日期范围最大值
  max: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 同 DatePicker
  placeholder: _react.PropTypes.string,

  // 同 DatePicker
  captionRender: _react.PropTypes.func,

  // 同 DatePicker
  weekDayNames: _react.PropTypes.array,

  customProp: function customProp(_ref) {
    var start = _ref.start;
    var end = _ref.end;
    var onSelect = _ref.onSelect;

    if ((start || end) && !onSelect) {
      return new Error('You provided a `start` or `end` prop without an `onSelect` handler');
    }
  }
};

exports.default = DateRange;