'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _controlled = require('../_shared/propValidator/controlled');

var _controlled2 = _interopRequireDefault(_controlled);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _DropdownToggle = require('./DropdownToggle');

var _DropdownToggle2 = _interopRequireDefault(_DropdownToggle);

var _DropdownMenu = require('./DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Dropdown = (function (_Component) {
  (0, _inherits3.default)(Dropdown, _Component);

  function Dropdown(props) {
    (0, _classCallCheck3.default)(this, Dropdown);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Dropdown).call(this));

    _this.state = {
      open: props.open || false
    };
    return _this;
  }

  (0, _createClass3.default)(Dropdown, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'open' in nextProps && this.setState({ open: nextProps.open });
    }

    /**
     * @public
     * @name this.refs.dropdown.open
     * @description 展开
     */

  }, {
    key: 'open',
    value: function open() {
      this.setState({ open: true });
    }

    /**
     * @public
     * @name this.refs.dropdown.close
     * @description 收起
     */

  }, {
    key: 'close',
    value: function close() {
      this.setState({ open: false });
    }
  }, {
    key: 'handleToggle',
    value: function handleToggle(open) {
      this.setState({ open: open });
      this.props.onToggle && this.props.onToggle(open);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var onToggle = _props.onToggle;
      var disabled = _props.disabled;
      var aligned = _props.aligned;
      var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'onToggle', 'disabled', 'aligned']);
      var open = this.state.open;

      delete other.open;

      _react2.default.Children.forEach(children, function (child) {
        if (child.type === _DropdownToggle2.default) {
          _this2.DropdownToggle = child;
        } else if (child.type === _DropdownMenu2.default) {
          _this2.DropdownMenu = child;
        }
      });

      var _DropdownMenu$props = this.DropdownMenu.props;
      var right = _DropdownMenu$props.right;
      var menuProps = (0, _objectWithoutProperties3.default)(_DropdownMenu$props, ['right']);

      menuProps.className = (0, _classnames2.default)('bfd-dropdown__popover', menuProps.className);
      if (right) {
        menuProps.align = 'right';
      }

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-dropdown', {
            'bfd-dropdown--open': open
          }, className) }, other),
        _react2.default.createElement(
          _Popover2.default,
          (0, _extends3.default)({
            triggerMode: 'click',
            open: open,
            onToggle: this.handleToggle.bind(this),
            content: menuProps.children,
            disabled: disabled,
            aligned: aligned
          }, menuProps),
          this.DropdownToggle
        )
      );
    }
  }]);
  return Dropdown;
})(_react.Component);

Dropdown.propTypes = {

  // 是否展开
  open: (0, _controlled2.default)(_react.PropTypes.bool, 'onToggle'),

  // 切换 open 状态后的回调，参数为切换后的 open 状态
  onToggle: _react.PropTypes.func,

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // DropdownToggle 与 DropdownMenu 宽度相同
  aligned: _react.PropTypes.bool
};

exports.default = Dropdown;