'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _formControlValue = require('../formControlValue');

var _formControlValue2 = _interopRequireDefault(_formControlValue);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var FormTextarea = function FormTextarea(props, context) {
  var children = props.children;
  var className = props.className;
  var onChange = props.onChange;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'onChange']);

  var control = (0, _formControlValue2.default)(context.form, context.formItem);
  var value = control.get();
  if (!value && value !== 0) {
    value = '';
  }
  other.value = value;
  other.onChange = function (e) {
    control.set(e.target.value);
    onChange && onChange(e);
  };
  return _react2.default.createElement('textarea', (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-form-textarea', className) }, other));
};

FormTextarea.contextTypes = {
  form: _react.PropTypes.object,
  formItem: _react.PropTypes.object
};

exports.default = FormTextarea;