'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactUpdate = require('react-update');

var _reactUpdate2 = _interopRequireDefault(_reactUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (form, formItem) {
  var name = formItem.props.name;
  return {
    get: function get() {
      var data = form.state.data[name];
      if (!formItem.props.multiple) {
        return data;
      } else {
        if (data instanceof Array) {
          return data[form.multipleMap[formItem.uuid]];
        }
        return null;
      }
    },
    set: function set(value) {
      var formData = form.state.data;
      var nextData = undefined;
      if (!formItem.props.multiple) {
        nextData = (0, _reactUpdate2.default)(formData, 'set', name, value);
      } else {
        if (!formData[name]) {
          formData[name] = [];
        }
        nextData = (0, _reactUpdate2.default)(formData, 'set', [name, form.multipleMap[formItem.uuid]], value);
      }
      form.setState({ data: nextData });
      form.props.onChange && form.props.onChange(nextData);
    }
  };
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */