'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Row = function Row(props) {
  var children = props.children;
  var className = props.className;
  var gutter = props.gutter;
  var fluid = props.fluid;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'gutter', 'fluid']);

  var classNames = (0, _classnames2.default)('bfd-row', {
    'bfd-row--gutter': gutter,
    'bfd-row--fluid': fluid
  }, className);
  return _react2.default.createElement(
    'div',
    (0, _extends3.default)({ className: classNames }, other),
    children
  );
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */

Row.propTypes = {

  // 是否带间隔
  gutter: _react.PropTypes.bool,

  // 是否流式布局，按内容自适应自左向右布局
  fluid: _react.PropTypes.bool
};

exports.default = Row;