'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCssTransitionGroup = require('react-addons-css-transition-group');

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _classlist = require('classlist');

var _classlist2 = _interopRequireDefault(_classlist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var scrollbarWidth = (function () {
  var scrollDiv = document.createElement('div');
  var body = document.body;

  scrollDiv.className = 'bfd-modal--scrollbar-measure';
  body.appendChild(scrollDiv);
  var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
  body.removeChild(scrollDiv);

  return scrollbarWidth;
})();

var Modal = (function (_Component) {
  (0, _inherits3.default)(Modal, _Component);

  function Modal(props) {
    (0, _classCallCheck3.default)(this, Modal);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Modal).call(this, props));

    _this.closeTimeout = 150;

    _this.state = {
      open: props.open || false
    };
    return _this;
  }

  (0, _createClass3.default)(Modal, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        modal: this
      };
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'open' in nextProps && this.setState({ open: nextProps.open });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(this.state.open === nextState.open && nextState.open === false);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateBodyState(this.state.open, false);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      this.updateBodyState(this.state.open, prevState.open);
    }
  }, {
    key: 'updateBodyState',
    value: function updateBodyState(open, prevOpen) {
      var body = document.body;
      var bodyPaddingRight = parseInt(body.style.paddingRight, 10) || 0;
      var _scrollbarWidth = body.scrollHeight > window.innerHeight ? scrollbarWidth : 0;
      if (open && !prevOpen) {
        (0, _classlist2.default)(body).add('bfd-modal--open');
        body.style.paddingRight = bodyPaddingRight + _scrollbarWidth + 'px';
      } else if (!open && prevOpen) {
        setTimeout(function () {
          (0, _classlist2.default)(body).remove('bfd-modal--open');
          if (bodyPaddingRight) {
            body.style.paddingRight = bodyPaddingRight - _scrollbarWidth + 'px';
          } else {
            body.style.paddingRight = '';
          }
        }, this.closeTimeout);
      }
    }
  }, {
    key: 'handleModalClick',
    value: function handleModalClick(e) {
      if (!this.props.lock && e.target.className === 'bfd-modal__modal') {
        this.close();
      }
    }

    /**
     * @public
     * @name this.refs.modal.open
     * @description 打开模态框
     */

  }, {
    key: 'open',
    value: function open() {
      this.setState({ open: true });
      this.props.onToggle && this.props.onToggle(true);
    }

    /**
     * @public
     * @name this.refs.modal.close
     * @param {function} [callback] 关闭后的回调，动画结束后执行
     * @description 关闭模态框
     */

  }, {
    key: 'close',
    value: function close() {
      var callback = arguments.length <= 0 || arguments[0] === undefined ? this.props.onClose : arguments[0];

      this.setState({ open: false });
      this.props.onToggle && this.props.onToggle(false);
      callback && setTimeout(callback, this.closeTimeout);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var onToggle = _props.onToggle;
      var lock = _props.lock;
      var onClose = _props.onClose;
      var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'onToggle', 'lock', 'onClose']);
      var open = this.state.open;

      delete other.open;

      return _react2.default.createElement(
        _reactAddonsCssTransitionGroup2.default,
        {
          transitionName: 'bfd-modal--in',
          transitionEnterTimeout: 200,
          transitionLeaveTimeout: this.closeTimeout
        },
        open && _react2.default.createElement(
          'div',
          (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-modal', className) }, other),
          _react2.default.createElement('div', { className: 'bfd-modal__backdrop' }),
          _react2.default.createElement(
            'div',
            { className: 'bfd-modal__modal', onClick: this.handleModalClick.bind(this) },
            _react2.default.createElement(
              'div',
              { className: 'bfd-modal__modal-dialog' },
              _react2.default.createElement(
                'div',
                { className: 'bfd-modal__modal-content' },
                children
              )
            )
          )
        )
      );
    }
  }]);
  return Modal;
})(_react.Component);

Modal.childContextTypes = {
  modal: _react.PropTypes.instanceOf(Modal)
};

Modal.propTypes = {

  // 是否打开
  open: _react.PropTypes.bool,

  // 切换 open 状态后的回调，参数为切换后的 open 状态，立刻执行，不会等到动画结束后
  onToggle: _react.PropTypes.func,

  // 是否锁定，锁定后点击背景无法关闭
  lock: _react.PropTypes.bool,

  // 关闭后的回调，动画结束后执行。如果 close 方法传入回调，则此属性不会触发
  onClose: _react.PropTypes.func
};

exports.default = Modal;