'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Option = exports.MultipleSelect = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _shouldComponentUpdate = require('../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

var _Option = require('../Select/Option');

var _Option2 = _interopRequireDefault(_Option);

var _Checkbox = require('../Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _SelectDropdown = require('../SelectDropdown');

var _SelectDropdown2 = _interopRequireDefault(_SelectDropdown);

var _TagList = require('../TagList');

var _TagList2 = _interopRequireDefault(_TagList);

var _action = require('./action');

var _action2 = _interopRequireDefault(_action);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MultipleSelect = (function (_Component) {
  (0, _inherits3.default)(MultipleSelect, _Component);

  function MultipleSelect(props) {
    (0, _classCallCheck3.default)(this, MultipleSelect);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(MultipleSelect).call(this));

    _this.options = [];
    _this.state = {
      data: props.data || [],
      values: props.values || props.defaultValues || [],
      searchValue: '',
      index: -2
    };
    return _this;
  }

  (0, _createClass3.default)(MultipleSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      nextProps.values && this.setState({ values: nextProps.values });
      nextProps.data && this.setState({ data: nextProps.data });
    }
  }, {
    key: 'change',
    value: function change(values) {
      this.setState({
        values: values,
        searchValue: ''
      });
      this.refs.tagList.focus();
      this.props.onChange && this.props.onChange(values);
    }
  }, {
    key: 'toggleAll',
    value: function toggleAll(checked) {
      var _this2 = this;

      this.options.forEach(function (option) {
        _this2.valueSet[checked ? 'add' : 'delete'](option.props.value);
      });
      this.change([].concat((0, _toConsumableArray3.default)(this.valueSet)));
    }
  }, {
    key: 'addValue',
    value: function addValue(value) {
      this.valueSet.add(value);
      this.change([].concat((0, _toConsumableArray3.default)(this.valueSet)));
    }
  }, {
    key: 'removeValue',
    value: function removeValue(value) {
      this.valueSet.delete(value);
      this.change([].concat((0, _toConsumableArray3.default)(this.valueSet)));
    }
  }, {
    key: 'traverseOptions',
    value: function traverseOptions(callback) {
      var _this3 = this;

      var _props = this.props;
      var children = _props.children;
      var render = _props.render;

      if (children) {
        _react2.default.Children.forEach(children, function (option, i) {
          if (!option) return;
          callback(option, i);
        });
      } else {
        this.state.data.forEach(function (item, i) {
          callback(render.call(_this3, item, i), i);
        });
      }
    }
  }, {
    key: 'getCheckbox',
    value: function getCheckbox(value, children) {
      return _react2.default.createElement(
        _Checkbox2.default,
        {
          block: true,
          value: value,
          checked: this.valueSet.has(value),
          onChange: _action2.default.handleOptionCheck.bind(this, value)
        },
        children
      );
    }

    // 选中的标签

  }, {
    key: 'getLabels',
    value: function getLabels(optionsMapper) {
      var _this4 = this;

      var labels = [];
      this.state.values.forEach(function (key) {
        if (optionsMapper[key] || _this4.props.tagable) {
          labels.push({
            value: key,
            label: optionsMapper[key] || key
          });
        }
      });
      return labels;
    }

    // 上下切换

  }, {
    key: 'getWrapperOptions',
    value: function getWrapperOptions(options) {
      var _this5 = this;

      return options.map(function (option, i) {
        return _react2.default.createElement(
          'li',
          { key: i, className: (0, _classnames2.default)({
              'bfd-multiple-select__option': true,
              'bfd-multiple-select__option--active': _this5.state.index === i
            }) },
          option
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      var _props2 = this.props;
      var children = _props2.children;
      var className = _props2.className;
      var defaultValues = _props2.defaultValues;
      var onChange = _props2.onChange;
      var data = _props2.data;
      var url = _props2.url;
      var disabled = _props2.disabled;
      var tagable = _props2.tagable;
      var placeholder = _props2.placeholder;
      var noOptionsContent = _props2.noOptionsContent;
      var toggleAllContent = _props2.toggleAllContent;
      var other = (0, _objectWithoutProperties3.default)(_props2, ['children', 'className', 'defaultValues', 'onChange', 'data', 'url', 'disabled', 'tagable', 'placeholder', 'noOptionsContent', 'toggleAllContent']);
      var _state = this.state;
      var searchValue = _state.searchValue;
      var index = _state.index;
      var values = _state.values;

      delete other.values;
      delete other.render;

      var valueSet = this.valueSet = new _set2.default(values);
      var optionsMapper = {};
      var options = [];

      this.traverseOptions(function (option) {
        var _option$props = option.props;
        var value = _option$props.value;
        var children = _option$props.children;

        optionsMapper[value || children] = children;
        // 搜索过滤
        var searchValue = _this6.state.searchValue;

        if (searchValue && children.indexOf(searchValue) === -1 && (String(value) ? String(value).indexOf(searchValue) === -1 : true)) {
          return;
        }
        options.push(_this6.getCheckbox(value || children, children));
      });

      // 自定义标签模式，防止重复
      if (tagable && searchValue && (!options[0] || options[0].props.children !== searchValue)) {
        options.unshift(this.getCheckbox(searchValue, searchValue));
      }

      var labels = this.getLabels(optionsMapper);
      var wrapperOptions = this.getWrapperOptions(options);
      var isAll = options.filter(function (option) {
        return !valueSet.has(option.props.value);
      }).length === 0;

      this.options = options;
      this.isAll = isAll;

      var Title = _react2.default.createElement(_TagList2.default, {
        ref: 'tagList',
        inputable: true,
        inputValue: searchValue,
        onInput: _action2.default.handleInput.bind(this),
        onInputKeyChange: _action2.default.handleKeyDown.bind(this),
        labels: labels,
        placeholder: values && values.length ? '' : placeholder,
        onRemove: _action2.default.handleLabelRemove.bind(this),
        disabled: disabled
      });

      return _react2.default.createElement(
        _SelectDropdown2.default,
        (0, _extends3.default)({
          className: (0, _classnames2.default)('bfd-multiple-select', className),
          title: Title,
          url: url,
          onLoad: _action2.default.handleLoad.bind(this),
          hasPropValue: !!this.props.values || !!this.props.defaultValues,
          disabled: disabled,
          onToggle: _action2.default.handleDropdownToggle.bind(this)
        }, other),
        options.length ? _react2.default.createElement(
          'ul',
          null,
          _react2.default.createElement(
            'li',
            { className: (0, _classnames2.default)({
                'bfd-multiple-select__option': true,
                'bfd-multiple-select__option--active': index === -1
              }) },
            _react2.default.createElement(
              _Checkbox2.default,
              {
                checked: isAll,
                block: true,
                onChange: _action2.default.handleToggleAll.bind(this)
              },
              toggleAllContent
            )
          ),
          wrapperOptions
        ) : _react2.default.createElement(
          'div',
          { className: 'bfd-multiple-select__empty' },
          noOptionsContent
        )
      );
    }
  }]);
  return MultipleSelect;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

MultipleSelect.defaultProps = {
  placeholder: '请选择',
  noOptionsContent: '无选项',
  toggleAllContent: '全选'
};

MultipleSelect.propTypes = {

  // 选中的值
  values: _react.PropTypes.array,

  // 初始化时选中的值（不可控）
  defaultValues: _react.PropTypes.array,

  // 切换选择后的回调，参数为选中的值
  onChange: _react.PropTypes.func,

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // 是否开启自定义标签输入功能
  tagable: _react.PropTypes.bool,

  // Option 数据源，结合 render 使用
  data: _react.PropTypes.array,

  // 数据源 URL，直接请求服务器，内部调用 xhr 模块
  url: _react.PropTypes.string,

  // URL 数据源模式数据过滤，参数为服务器返回的数据，返回处理后的数据
  dataFilter: _react.PropTypes.func,

  // data / url 方式时 Option 渲染回调，参数为当前数据和索引，返回一个 Option
  render: _react.PropTypes.func,

  // 无 `values` 时显示的内容
  placeholder: _react.PropTypes.string,

  // 无选项时显示的内容
  noOptionsContent: _react.PropTypes.string,

  // 全选切换复选框显示的文字
  toggleAllContent: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var values = _ref.values;
    var onChange = _ref.onChange;
    var url = _ref.url;
    var render = _ref.render;

    if (values && !onChange) {
      return new Error('You provided a `values` prop without an `onChange` handler');
    }
    if (url && !render) {
      return new Error('You provided a `url` prop without an `render` handler');
    }
  }
};

exports.MultipleSelect = MultipleSelect;
exports.Option = _Option2.default;