'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (env, flag) {

  // clear tooltip.
  _d2.default.select(env.container).selectAll('.bcharts-tooltip').remove();

  // 添加一个提示框
  var tooltip = _d2.default.select(env.container).append('div').style({
    position: 'absolute',
    opacity: 0,
    'pointer-events': 'none'
  }).attr('class', 'bcharts-tooltip');

  env.svg.select('.pie-slices').selectAll('.bfd-pie-md').on('click', function (d) {
    _d2.default.select('.pie-slices').selectAll('.bfd-pie-lg').style('display', 'none');
    _d2.default.select('.pie-slices').selectAll('.bfd-pie-md').style('display', 'block');
    _d2.default.select(env.container).selectAll('.bfd-pie-flag').style('display', 'none');
    _d2.default.select('.pie-slices').selectAll('path[fill="' + d.data.color + '"]').style('display', 'block');
    _d2.default.select(this).style('display', 'none');

    if (env.config.tooltip.point && typeof env.config.tooltip.point.events.click === 'function') {
      env.config.tooltip.point.events.click(d.data);
    }
  });

  env.svg.select('.pie-slices').selectAll('.bfd-pie-md,.bfd-pie-lg').on('mouseover', function (d) {
    // 计算份额的百分比
    var percent = Number(d.value) / _d2.default.sum(flag ? env.config.data : env.config.dataLegend, function (d) {
      return d.value;
    }) * 100;

    tooltip.html(env.config.name + '<br/>' + d.data.name + ':' + d.data.value + '(' + percent.toFixed(0) + '%)').style('left', _d2.default.event.layerX + 'px').style('top', _d2.default.event.layerY + 50 + 'px').style('opacity', 1.0);
  }).on('mousemove', function () {
    /* left 和 top 来改变提示框的位置 */
    tooltip.style('left', _d2.default.event.layerX + 'px').style('top', _d2.default.event.layerY + 50 + 'px');
  }).on('mouseout', function () {
    tooltip.style('opacity', 0.0);
  });
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */