'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _classlist2 = require('classlist');

var _classlist3 = _interopRequireDefault(_classlist2);

var _ToggleNode = require('../_shared/ToggleNode');

var _ToggleNode2 = _interopRequireDefault(_ToggleNode);

var _CoordinateFactory3 = require('./CoordinateFactory');

var _CoordinateFactory4 = _interopRequireDefault(_CoordinateFactory3);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

window.addEventListener('click', function () {
  Popover.lastOpenedPopover && Popover.lastOpenedPopover.close();
});

var Popover = (function (_Component) {
  (0, _inherits3.default)(Popover, _Component);

  function Popover(props) {
    (0, _classCallCheck3.default)(this, Popover);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Popover).call(this));

    _this.state = {
      open: props.open || false
    };
    return _this;
  }

  (0, _createClass3.default)(Popover, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.open) {
        this.renderContent();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'open' in nextProps && this.setState({ open: nextProps.open });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.open) {
        this.renderContent();
      } else {
        prevState.open && this.toggleContent.close();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.containerNode) {
        _reactDom2.default.unmountComponentAtNode(this.containerNode);
        document.body.removeChild(this.containerNode);
      }
    }
  }, {
    key: 'getComputedDirection',
    value: function getComputedDirection(triggerRect, popoverRect) {
      var direction = this.props.direction;

      if (triggerRect.top < popoverRect.height) {
        direction = 'down';
      } else if (popoverRect.height + triggerRect.top + triggerRect.height > window.innerHeight) {
        direction = 'up';
      }
      return direction;
    }
  }, {
    key: 'setClassNamesByPosition',
    value: function setClassNamesByPosition(direction, align) {
      var _classnames;

      this.positionClassNames = (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, 'bfd-popover--' + direction, true), (0, _defineProperty3.default)(_classnames, 'bfd-popover--align-' + align, !!align), _classnames));
      (0, _classlist3.default)(this.contentNode).add(this.positionClassNames);
    }
  }, {
    key: 'setCoordinate',
    value: function setCoordinate(triggerRect, popoverRect, direction, align) {
      var _CoordinateFactory = (0, _CoordinateFactory4.default)(triggerRect, popoverRect, direction, align);

      var _CoordinateFactory2 = (0, _slicedToArray3.default)(_CoordinateFactory, 2);

      var left = _CoordinateFactory2[0];
      var top = _CoordinateFactory2[1];

      this.contentNode.style.left = left + 'px';
      this.contentNode.style.top = top + 'px';
    }
  }, {
    key: 'setPosition',
    value: function setPosition() {
      var align = this.props.align;

      // Prevent accumulation

      if (this.positionClassNames) {
        var _classlist;

        (_classlist = (0, _classlist3.default)(this.contentNode)).remove.apply(_classlist, (0, _toConsumableArray3.default)(this.positionClassNames.split(' ')));
      }

      // Calculate elements size
      var triggerRect = this.triggerNode.getBoundingClientRect();
      var popoverRect = this.contentNode.getBoundingClientRect();

      // Calculate direction with arrow and reCalculate contentNode size
      var direction = this.getComputedDirection(triggerRect, popoverRect);
      this.setClassNamesByPosition(direction, align);
      popoverRect = this.contentNode.getBoundingClientRect();

      this.setCoordinate(triggerRect, popoverRect, direction, align);
    }

    /**
     * @public
     * @name popover.open()
     * @description 打开浮层
     */

  }, {
    key: 'open',
    value: function open() {
      var _props = this.props;
      var shouldOpen = _props.shouldOpen;
      var onToggle = _props.onToggle;

      if (!shouldOpen || shouldOpen()) {
        this.setState({ open: true });
        onToggle && onToggle(true);

        if (Popover.lastOpenedPopover && Popover.lastOpenedPopover !== this) {
          Popover.lastOpenedPopover.close();
        }
        Popover.lastOpenedPopover = this;
      }
    }

    /**
     * @public
     * @name popover.close()
     * @description 关闭浮层
     */

  }, {
    key: 'close',
    value: function close() {
      var _props2 = this.props;
      var shouldClose = _props2.shouldClose;
      var onToggle = _props2.onToggle;

      if (!shouldClose || shouldClose()) {
        this.setState({ open: false });
        onToggle && onToggle(false);
      }
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var _this2 = this;

      if (!this.containerNode) {
        this.containerNode = document.createElement('div');
        document.body.appendChild(this.containerNode);
      }
      this.triggerNode = _reactDom2.default.findDOMNode(this);

      this.renderContent = function () {
        var _props3 = _this2.props;
        var className = _props3.className;
        var triggerMode = _props3.triggerMode;
        var content = _props3.content;
        var direction = _props3.direction;
        var align = _props3.align;
        var open = _props3.open;
        var onToggle = _props3.onToggle;
        var shouldOpen = _props3.shouldOpen;
        var shouldClose = _props3.shouldClose;
        var disabled = _props3.disabled;
        var aligned = _props3.aligned;
        var other = (0, _objectWithoutProperties3.default)(_props3, ['className', 'triggerMode', 'content', 'direction', 'align', 'open', 'onToggle', 'shouldOpen', 'shouldClose', 'disabled', 'aligned']);

        if (triggerMode === 'hover') {
          other.onMouseEnter = function () {
            clearTimeout(_this2.closeTimer);
          };
          other.onMouseLeave = function () {
            _this2.closeTimer = setTimeout(function () {
              return _this2.close();
            }, Popover.LAZY_DURATION);
          };
        } else {
          other.onClick = function (e) {
            return e.stopPropagation();
          };
        }

        if (aligned) {
          other.style = (0, _assign2.default)(other.style || {}, {
            width: _this2.triggerNode.offsetWidth
          });
        }

        _reactDom2.default.render(_react2.default.createElement(
          'div',
          { className: 'bfd-popover', ref: function ref(node) {
              _this2.contentNode = node;
            } },
          _react2.default.createElement(
            'div',
            (0, _extends3.default)({ className: (0, _classnames3.default)('bfd-popover__content', className) }, other),
            content
          )
        ), _this2.containerNode, function () {
          if (!_this2.toggleContent) {
            _this2.toggleContent = new _ToggleNode2.default(_this2.contentNode, 'bfd-popover--open', _this2.setPosition.bind(_this2));
          } else {
            _this2.toggleContent.setNode(_this2.contentNode);
          }
          _this2.toggleContent.open();
        });
      };
      this.renderContent();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props4 = this.props;
      var children = _props4.children;
      var triggerMode = _props4.triggerMode;
      var disabled = _props4.disabled;
      var open = this.state.open;

      var triggerProps = {
        className: (0, _classnames3.default)(children.props.className, 'bfd-popover__trigger', {
          'bfd-popover__trigger--disabled': disabled
        })
      };
      if (!disabled) {
        triggerProps.onClick = function (e) {
          e.stopPropagation();
          if (triggerMode === 'click') {
            _this3[open ? 'close' : 'open']();
          }
          children.props.onClick && children.props.onClick();
        };

        if (triggerMode === 'hover') {
          triggerProps.onMouseEnter = function () {
            clearTimeout(_this3.closeTimer);
            _this3.openTimer = setTimeout(_this3.open.bind(_this3), Popover.LAZY_DURATION);
            children.props.onMouseEnter && children.props.onMouseEnter();
          };
          triggerProps.onMouseLeave = function () {
            clearTimeout(_this3.openTimer);
            _this3.closeTimer = setTimeout(_this3.close.bind(_this3), Popover.LAZY_DURATION);
            children.props.onMouseLeave && children.props.onMouseLeave();
          };
        }
      }
      return _react2.default.cloneElement(children, triggerProps);
    }
  }]);
  return Popover;
})(_react.Component);

Popover.LAZY_DURATION = 150;
Popover.lastOpenedPopover = null;

Popover.defaultProps = {
  direction: 'up',
  triggerMode: 'hover'
};

Popover.propTypes = {
  children: _react.PropTypes.element.isRequired,
  triggerMode: _react.PropTypes.oneOf(['click', 'hover']),
  content: _react.PropTypes.node,
  direction: _react.PropTypes.oneOf(['up', 'down', 'left', 'right']),
  align: _react.PropTypes.oneOf(['top', 'right', 'bottom', 'left', 'middle']),
  open: _react.PropTypes.bool,
  onToggle: _react.PropTypes.func,
  shouldOpen: _react.PropTypes.func,
  shouldClose: _react.PropTypes.func,
  disabled: _react.PropTypes.bool,
  aligned: _react.PropTypes.bool
};

exports.default = Popover;