'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _ClearableInput = require('../ClearableInput');

var _ClearableInput2 = _interopRequireDefault(_ClearableInput);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./main.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SearchInput = (function (_Component) {
  (0, _inherits3.default)(SearchInput, _Component);

  function SearchInput() {
    (0, _classCallCheck3.default)(this, SearchInput);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SearchInput).call(this));

    _this.value = '';
    return _this;
  }

  (0, _createClass3.default)(SearchInput, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.value = this.props.defaultValue || '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var label = _props.label;
      var size = _props.size;
      var defaultValue = _props.defaultValue;
      var onSearch = _props.onSearch;
      var onChange = _props.onChange;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'label', 'size', 'defaultValue', 'onSearch', 'onChange']);

      var width = this.props.width || '300px';

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-search_input', className, size) }, other),
        _react2.default.createElement(_ClearableInput2.default, { style: { width: width }, defaultValue: this.value, size: size, onKeyUp: this.handleKeyUp.bind(this), onChange: this.handleChange.bind(this), inline: true, placeholder: this.props.placeholder || '' }),
        _react2.default.createElement(
          _Button2.default,
          { size: size, onClick: this.handleClick.bind(this), icon: 'search' },
          this.props.label || '搜索'
        )
      );
    }
  }, {
    key: 'handleChange',
    value: function handleChange(v) {
      this.value = v;
      this.props.onChange && this.props.onChange(v);
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      if (typeof this.props.onSearch == 'function') {
        this.props.onSearch(this.value);
      }
    }
  }, {
    key: 'handleKeyUp',
    value: function handleKeyUp(e) {
      e.preventDefault();
      var code = e.keyCode;
      if (code == 13) {
        this.handleClick();
      }
    }
  }]);
  return SearchInput;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

SearchInput.propTypes = {

  // 搜索框提示信息
  placeholder: _react.PropTypes.string,

  // 搜索按钮名称，默认为“搜索”
  label: _react.PropTypes.string,

  // 搜索按钮单击事件，value为搜索框输入值
  onSearch: _react.PropTypes.func.isRequired,

  // 搜索框值改变事件，value为搜索框输入值
  onChange: _react.PropTypes.func,

  // 输入框高度尺寸，参考 Bootstrap input，可选值：lg, sm，默认为lg
  size: _react.PropTypes.string,

  // 输入框默认值
  defaultValue: _react.PropTypes.string,

  // 输入框宽度，默认为300px
  width: _react.PropTypes.string
};

exports.default = SearchInput;