'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _controlled = require('../_shared/propValidator/controlled');

var _controlled2 = _interopRequireDefault(_controlled);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var SearchInput2 = (function (_Component) {
  (0, _inherits3.default)(SearchInput2, _Component);

  function SearchInput2(props) {
    (0, _classCallCheck3.default)(this, SearchInput2);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SearchInput2).call(this));

    _this.state = {
      value: 'value' in props ? props.value : props.defaultValue
    };
    return _this;
  }

  (0, _createClass3.default)(SearchInput2, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({ value: nextProps.value });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      var value = e.target.value;

      this.setState({ value: value });
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'handleSearch',
    value: function handleSearch() {
      this.props.onSearch && this.props.onSearch(this.state.value);
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      if (this.props.onSearch && e.key === 'Enter') {
        this.props.onSearch(this.state.value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var defaultValue = _props.defaultValue;
      var onChange = _props.onChange;
      var onSearch = _props.onSearch;
      var block = _props.block;
      var inputProps = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultValue', 'onChange', 'onSearch', 'block']);
      var value = this.state.value;

      delete inputProps.value;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('bfd-search-input2', {
            'bfd-search-input2--block': block
          }, className) },
        _react2.default.createElement(_Input2.default, (0, _extends3.default)({
          value: value,
          onChange: this.handleChange.bind(this),
          onKeyDown: this.handleKeyDown.bind(this)
        }, inputProps)),
        _react2.default.createElement(_Button2.default, {
          tabIndex: '-1',
          icon: 'search',
          size: 'sm',
          transparent: true,
          className: 'bfd-search-input2__search',
          onClick: this.handleSearch.bind(this)
        })
      );
    }
  }]);
  return SearchInput2;
})(_react.Component);

SearchInput2.defaultProps = {
  placeholder: '请输入关键词'
};

SearchInput2.propTypes = {

  // 输入框的值
  value: (0, _controlled2.default)(_react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number])),

  // 初始化输入框的值
  defaultValue: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 输入改变后的回调，参数为当前输入框的值
  onChange: _react.PropTypes.func,

  // 搜索事件
  onSearch: _react.PropTypes.func,

  // 输入框尺寸
  size: _react.PropTypes.oneOf(['sm', 'lg']),

  // 同 input placeholder，默认`请输入关键词`
  placeholder: _react.PropTypes.string,

  // 是否块级元素显示，块级显示则宽度 `100%`
  block: _react.PropTypes.bool
};

exports.default = SearchInput2;