'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TextOverflow = require('../../TextOverflow');

var _TextOverflow2 = _interopRequireDefault(_TextOverflow);

var _Icon = require('../../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Option = function Option(props) {
  var children = props.children;
  var className = props.className;
  var data = props.data;
  var value = props.value;
  var selected = props.selected;
  var active = props.active;
  var other = (0, _objectWithoutProperties3.default)(props, ['children', 'className', 'data', 'value', 'selected', 'active']);

  var classNames = (0, _classnames2.default)('bfd-select__option', {
    'bfd-select__option--active': active,
    'bfd-select__option--selected': selected
  }, className);
  return _react2.default.createElement(
    'li',
    (0, _extends3.default)({ className: classNames }, other),
    _react2.default.createElement(
      _TextOverflow2.default,
      null,
      _react2.default.createElement(
        'div',
        null,
        children
      )
    ),
    selected && _react2.default.createElement(_Icon2.default, { type: 'check', className: 'bfd-select__option-icon--selected' })
  );
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */

Option.propTypes = {

  // 值，与 Select value 对应，数据类型也要一致
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  selected: _react.PropTypes.bool,
  active: _react.PropTypes.bool
};

exports.default = Option;