'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./main.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Slider = (function (_Component) {
  (0, _inherits3.default)(Slider, _Component);

  function Slider() {
    (0, _classCallCheck3.default)(this, Slider);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Slider).call(this));

    _this.isDown = false;
    _this.width = 0;
    _this.offsetLeft = 0;
    _this.marginLeft = 0;
    _this.sliderWidth = 0;
    _this.mouseMoveFn = null;
    _this.mouseUpFn = null;
    return _this;
  }

  (0, _createClass3.default)(Slider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var bar = this.refs.bar;
      var selectedBar = this.refs.selectedBar;
      var slider = this.refs.slider;
      var style = getComputedStyle(bar);
      var sliderStyle = getComputedStyle(slider);
      var defaultValue = this.props.defaultValue || this.props.start || 0;

      this.width = parseInt(style.width, 10);
      this.sliderWidth = parseInt(sliderStyle.width, 10);
      this.offsetLeft = this.getOffsetLeft(bar) + this.marginLeft;
      slider.style.left = this.getTickValue(defaultValue) - parseInt(sliderStyle.width) / 2 + 'px';
      selectedBar.style.width = this.getTickValue(defaultValue) + 'px';

      this.refs.msg.innerHTML = defaultValue + (this.props.suffix || '');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var defaultValue = _props.defaultValue;
      var tickValue = _props.tickValue;
      var start = _props.start;
      var end = _props.end;
      var suffix = _props.suffix;
      var onSliding = _props.onSliding;
      var onSlid = _props.onSlid;
      var other = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultValue', 'tickValue', 'start', 'end', 'suffix', 'onSliding', 'onSlid']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ ref: 'container', className: (0, _classnames2.default)('bfd-slider', className) }, other),
        _react2.default.createElement(
          'div',
          { ref: 'bar', className: 'bfd-slider__bar' },
          _react2.default.createElement(
            'div',
            { ref: 'slider', className: 'bfd-slider__slider', onMouseDown: this.handleMouseDown.bind(this) },
            _react2.default.createElement(
              'div',
              { ref: 'tip', className: 'bfd-slider__tooltips' },
              _react2.default.createElement(
                'span',
                { ref: 'msg', className: 'bfd-slider__tooltips-text' },
                '0',
                this.props.suffix || ''
              ),
              _react2.default.createElement('div', { className: 'bfd-slider__tooltips-arrow-down' })
            )
          ),
          _react2.default.createElement('div', { ref: 'selectedBar', className: 'bfd-slider__bar--selected' }),
          _react2.default.createElement(Scale, { start: this.props.start || 0, end: this.props.end, tickValue: this.props.tickValue })
        )
      );
    }
  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(event) {
      event.stopPropagation();
      this.isDown = true;
      var BODY = document.body;
      BODY.style.cursor = 'default';
      this.mouseMoveFn = this.handleMouseMove.bind(this);
      this.mouseUpFn = this.handleMouseUp.bind(this);
      BODY.addEventListener('mousemove', this.mouseMoveFn);
      BODY.addEventListener('mouseup', this.mouseUpFn);
    }
  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(event) {
      var slider = this.refs.slider;
      var selectedBar = this.refs.selectedBar;

      if (this.isDown) {
        var left = event.pageX - this.offsetLeft - this.sliderWidth / 4;
        if (left <= 0) {
          left = 0;
          selectedBar.style.width = left + 'px';
        } else if (left >= this.width - this.sliderWidth / 2) {
          left = this.width - this.sliderWidth / 2;
          selectedBar.style.width = this.width + 'px';
        } else {
          selectedBar.style.width = left + 'px';
        }
        slider.style.left = left + 'px';
        var text = this.getValue(parseInt(selectedBar.style.width, 10));
        this.refs.msg.innerHTML = text + (this.props.suffix || '');
        if (typeof this.props.onSliding == 'function') {
          this.props.onSliding(text);
        }
      }
    }
  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp() {
      var selectedBar = this.refs.selectedBar;
      if (typeof selectedBar == 'undefined') {
        return;
      }
      this.isDown = false;
      var text = this.getValue(parseInt(selectedBar.style.width, 10));
      if (typeof this.props.onSlid == 'function') {
        this.props.onSlid(text);
      }

      var BODY = document.body;
      BODY.style.cursor = '';
      BODY.removeEventListener('mousemove', this.mouseMoveFn);
      BODY.removeEventListener('mouseup', this.mouseUpFn);
    }
  }, {
    key: 'getOffsetLeft',
    value: function getOffsetLeft(el) {
      var left = 0;
      var offsetParent = el;
      while (offsetParent != null && offsetParent != document.body) {
        left += offsetParent.offsetLeft;
        offsetParent = offsetParent.offsetParent;
      }
      return left;
    }
  }, {
    key: 'getValue',
    value: function getValue(currWidth) {
      var end = this.props.end;
      var start = this.props.start || 0;
      var v = Math.abs(end - start);
      var width = this.width;
      var value = v * currWidth / width + start;
      var digit = 0;
      if (end <= 10) {
        digit = 1;
      }
      return value.toFixed(digit);
    }
  }, {
    key: 'getTickValue',
    value: function getTickValue(value) {
      var end = this.props.end;
      var start = this.props.start || 0;
      var v = Math.abs(end) - Math.abs(start);
      v == 0 ? 1 : v;
      var width = this.width;
      return width / v * value;
    }
  }]);
  return Slider;
})(_react.Component); /**
                       * Copyright 2016-present, Baifendian, Inc.
                       * All rights reserved.
                       *
                       * This source code is licensed under the BSD-style license found in the
                       * LICENSE file in the root directory of this source tree. An additional grant
                       * of patent rights can be found in the PATENTS file in the same directory.
                       */

var Scale = (function (_Component2) {
  (0, _inherits3.default)(Scale, _Component2);

  function Scale() {
    (0, _classCallCheck3.default)(this, Scale);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Scale).call(this));
  }

  (0, _createClass3.default)(Scale, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.tickValue = this.props.tickValue || 5;
    }
  }, {
    key: 'render',
    value: function render() {
      var rows = [];
      for (var i = 0; i <= this.tickValue; i++) {
        rows.push(_react2.default.createElement(
          'div',
          { key: i, ref: 't' + i, className: 'bfd-scale__tick' },
          _react2.default.createElement('div', null),
          i
        ));
      }

      return _react2.default.createElement(
        'div',
        { ref: 'container', className: (0, _classnames2.default)('bfd-scale', this.props.className) },
        rows
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      var container = this.refs.container;
      var containerStyle = getComputedStyle(container);
      var width = parseInt(containerStyle.width);
      var scope = this.props.end - (this.props.start || 0);
      this.width = width;
      this.scope = scope;
      var arr = this.getTick(this.tickValue);
      arr.map(function (tick, index) {
        var value = scope / width * tick + _this3.props.start;
        if (index == 0) {
          value = _this3.props.start;
        }
        if (index == arr.length - 1) {
          value = _this3.props.end;
        }

        var el = _this3.refs['t' + index];
        el.innerHTML = '<div></div>' + parseInt(Math.round(value));
        if (index == 0) {
          el.style.left = 4 + 'px';
        } else if (index == _this3.tickValue) {
          el.style.left = parseInt(tick) - 1 + 'px';
        } else {
          el.style.left = tick + 'px';
        }
      });
    }
  }, {
    key: 'getTick',
    value: function getTick(num) {
      var arr = [];
      num = !num ? 1 : num;
      var w = this.width / num;
      for (var i = 0; i < num; i++) {
        arr.push(i * w);
      }
      arr.push(this.width);

      return arr;
    }
  }]);
  return Scale;
})(_react.Component);

Slider.propTypes = {

  // 默认值
  defaultValue: _react.PropTypes.number,

  // 标尺刻度数量，默认5
  tickValue: _react.PropTypes.number,

  // 起始值，默认值为0
  start: _react.PropTypes.number,

  // 结束值
  end: _react.PropTypes.number.isRequired,

  // 后缀
  suffix: _react.PropTypes.string.isRequired,

  // 滑块拖动进行时事件，value为拖动条当前值
  onSliding: _react.PropTypes.func,

  // 滑块拖动完成时事件，即鼠标抬起后执行，value为拖动条当前值
  onSlid: _react.PropTypes.func.isRequired
};

exports.default = Slider;