'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _controlled = require('../_shared/propValidator/controlled');

var _controlled2 = _interopRequireDefault(_controlled);

var _extend = require('../_shared/propValidator/extend');

var _extend2 = _interopRequireDefault(_extend);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Slider2 = (function (_Component) {
  (0, _inherits3.default)(Slider2, _Component);

  function Slider2(props) {
    (0, _classCallCheck3.default)(this, Slider2);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Slider2).call(this));

    _this.handleDragging = _this.handleDragging.bind(_this);
    _this.handleDragEnd = _this.handleDragEnd.bind(_this);

    _this.shouldPopoverToggle = true;

    _this.isSliderFromDrag = false;
    _this.isSliderFromClick = false;

    _this.state = {
      value: ('value' in props ? props.value : props.defaultValue) || 0
    };
    return _this;
  }

  (0, _createClass3.default)(Slider2, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.componentDidRender();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({ value: nextProps.value });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.componentDidRender();
    }
  }, {
    key: 'handleDragStart',
    value: function handleDragStart(e) {
      if (e.button === 0) {
        if (this.props.disabled) {
          return;
        }
        this.isSliderFromDrag = true;
        this.isSliderFromClick = false;
        this.shouldPopoverToggle = false;
        e.preventDefault();
        window.addEventListener('mousemove', this.handleDragging);
        window.addEventListener('mouseup', this.handleDragEnd);
      }
    }
  }, {
    key: 'handleDragging',
    value: function handleDragging(e) {
      var value = this.mousePositionDidChange(e);
      if (typeof value === 'number') {
        this.props.onDragging && this.props.onDragging(value);
      }
    }
  }, {
    key: 'handleDragEnd',
    value: function handleDragEnd(e) {
      if (e.target === this.sliderNode) {
        this.isSliderFromDrag = false;
      }
      this.shouldPopoverToggle = true;
      window.removeEventListener('mousemove', this.handleDragging);
      window.removeEventListener('mouseup', this.handleDragEnd);
      this.props.onChange && this.props.onChange(this.state.value);
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      if (this.isSliderFromDrag) {
        this.isSliderFromDrag = false;
        return;
      }
      if (this.props.disabled) {
        return;
      }
      var value = this.mousePositionDidChange(e);
      if (typeof value === 'number') {
        this.props.onChange && this.props.onChange(value);
      }
      this.updatePosition();
      this.popover.open();
      this.shouldPopoverToggle = false;
      this.isSliderFromClick = true;
    }
  }, {
    key: 'handleMouseLeave',
    value: function handleMouseLeave() {
      if (this.isSliderFromClick) {
        this.shouldPopoverToggle = true;
        this.isSliderFromClick = false;
        this.popover.close();
      }
    }
  }, {
    key: 'mousePositionDidChange',
    value: function mousePositionDidChange(e) {
      var offsetLeft = e.pageX - this.pageX;
      if (offsetLeft > this.width) {
        offsetLeft = this.width;
      } else if (offsetLeft < 0) {
        offsetLeft = 0;
      }
      var stepIndex = Math.round(offsetLeft / this.stepWidth);
      if (this.stepIndex !== stepIndex) {
        this.stepIndex = stepIndex;
        var value = this.props.min + this.stepIndex * this.props.step;
        this.setState({ value: value });
        return value;
      }
    }
  }, {
    key: 'componentDidRender',
    value: function componentDidRender() {
      if (!this.isSliderFromDrag && !this.isSliderFromClick) {
        this.prepareContext();
      }
      if (!this.isSliderFromClick) {
        this.updatePosition();
      }
    }
  }, {
    key: 'prepareContext',
    value: function prepareContext() {
      var _props = this.props;
      var min = _props.min;
      var max = _props.max;
      var step = _props.step;

      this.pageX = this.layerNode.getBoundingClientRect().left;
      this.width = this.layerNode.offsetWidth;
      this.stepCount = (max - min) / step;
      this.stepWidth = this.width / this.stepCount;
      this.stepIndex = Math.round((this.state.value - min) / step);
    }
  }, {
    key: 'updatePosition',
    value: function updatePosition() {
      var offsetLeft = this.stepIndex / this.stepCount * 100 + '%';
      this.sliderNode.style.left = offsetLeft;
      this.rangeNode.style.width = offsetLeft;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var className = _props2.className;
      var min = _props2.min;
      var max = _props2.max;
      var step = _props2.step;
      var value = _props2.value;
      var defaultValue = _props2.defaultValue;
      var formatter = _props2.formatter;
      var onDragging = _props2.onDragging;
      var onChange = _props2.onChange;
      var disabled = _props2.disabled;
      var other = (0, _objectWithoutProperties3.default)(_props2, ['className', 'min', 'max', 'step', 'value', 'defaultValue', 'formatter', 'onDragging', 'onChange', 'disabled']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({
          className: (0, _classnames2.default)('bfd-slider2', {
            'bfd-slider2--disabled': disabled
          }, className),
          onClick: this.handleClick.bind(this),
          onMouseLeave: this.handleMouseLeave.bind(this)
        }, other),
        _react2.default.createElement(
          'div',
          { className: 'bfd-slider2__layer', ref: function ref(node) {
              return _this2.layerNode = node;
            } },
          _react2.default.createElement('div', { className: 'bfd-slider2__range', ref: function ref(node) {
              return _this2.rangeNode = node;
            } }),
          _react2.default.createElement(
            _Popover2.default,
            {
              content: formatter(this.state.value),
              shouldOpen: function shouldOpen() {
                return _this2.shouldPopoverToggle;
              },
              shouldClose: function shouldClose() {
                return _this2.shouldPopoverToggle;
              },
              ref: function ref(popover) {
                return _this2.popover = popover;
              }
            },
            _react2.default.createElement('div', {
              className: 'bfd-slider2__slider',
              onMouseDown: this.handleDragStart.bind(this),
              onMouseLeave: this.handleMouseLeave.bind(this),
              ref: function ref(node) {
                return _this2.sliderNode = node;
              }
            })
          )
        )
      );
    }
  }]);
  return Slider2;
})(_react.Component);

Slider2.defaultProps = {
  min: 0,
  max: 100,
  step: 1,
  formatter: function formatter(value) {
    return value;
  }
};

Slider2.propTypes = {

  // 最小值，默认0
  min: _react.PropTypes.number,

  // 最大值，默认100
  max: _react.PropTypes.number,

  // 步长，默认1
  step: (0, _extend2.default)(_react.PropTypes.number, function (props) {
    if (props.step > props.max) return '`step` prop should not be greater than `max` prop.';
  }),

  // 值
  value: (0, _controlled2.default)(_react.PropTypes.number),

  // 同 value，不可控
  defaultValue: _react.PropTypes.number,

  // 提示框内容格式器，默认 `formatter: value => value`
  formatter: _react.PropTypes.func,

  // 拖动过程事件，参数为当前拖动条的值
  onDragging: _react.PropTypes.func,

  // 拖动完成或点击后的回调，参数为当前拖动条的值
  onChange: _react.PropTypes.func,

  // 是否禁用
  disabled: _react.PropTypes.bool
};

exports.default = Slider2;