'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _class = (function () {
  function _class(config) {
    (0, _classCallCheck3.default)(this, _class);

    this.div = config.div;
    this.arrow = config.arrow;
    this.svg = config.svg;
    this.padding = config.padding;
    this.height = config.height;
    this.xScale = config.xScale;
    this.yScale = config.yScale;
  }

  (0, _createClass3.default)(_class, [{
    key: 'resetYScale',
    value: function resetYScale(yScale) {
      this.yScale = yScale;
    }
  }, {
    key: 'create',
    value: function create(series, dataset, nameSet, count, index) {
      var div = this.div;
      var arrow = this.arrow;
      var padding = this.padding;
      var xScale = this.xScale;
      var yScale = this.yScale;
      var height = this.height;
      this.rect = this.svg.selectAll().data(dataset.data).enter().append('rect').attr('class', 'MyRect').on('mouseover', function (d, i) {
        var x = parseFloat(_d2.default.select(this).attr('x'));
        var width = parseFloat(_d2.default.select(this).attr('width'));
        var sum = 0;
        for (var j = 0; j < series.length; j++) {
          var value = series[j].data[i];
          sum += value;
          if (index == j) {
            break;
          }
        }
        div.transition().duration(200).style('opacity', .9);

        arrow.transition().duration(200).style('opacity', .9);

        div.html(dataset.name + '：' + d).style('left', padding.left + x - div[0][0].clientWidth / 2 + width / 2 + 'px').style('top', yScale(sum) + 16 + 'px');

        arrow.style('left', padding.left + x + width / 2 - 6 + 'px').style('top', yScale(sum) + div[0][0].clientHeight + 16 + 'px');
        _d2.default.select(this).attr('opacity', '0.8');
      }).on('mouseout', function () {
        div.transition().duration(500).style('opacity', 0);

        arrow.transition().duration(500).style('opacity', 0);
        _d2.default.select(this).attr('opacity', 1);
      }).attr('transform', 'translate(' + padding.left + ',' + padding.top + ')').attr('x', function (d, i) {
        var innerPading = xScale.rangeBand() / 4;
        return xScale(nameSet[i]) + innerPading;
      }).attr('width', xScale.rangeBand() / 2).attr('y', function () {
        var min = yScale.domain()[0];
        return yScale(min);
      }).attr('height', function () {
        return 0;
      }).attr('fill', dataset.color).transition().delay(function (d, i) {
        return i * 0;
      }).duration(2000).ease('bounce').attr('y', function (d, i) {
        var sum = 0;
        for (var j = 0; j < series.length; j++) {
          var value = series[j].data[i];
          sum += value;
          if (index == j) {
            break;
          }
        }
        return yScale(sum);
      }).attr('height', function (d) {
        return height - yScale(d);
      }).attr('fill', dataset.color);
      return this;
    }
  }]);
  return _class;
})(); /**
       * Copyright 2016-present, Baifendian, Inc.
       * All rights reserved.
       *
       * This source code is licensed under the BSD-style license found in the
       * LICENSE file in the root directory of this source tree. An additional grant
       * of patent rights can be found in the PATENTS file in the same directory.
       */

exports.default = _class;