'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Tab = (function (_Component) {
  (0, _inherits3.default)(Tab, _Component);

  function Tab() {
    (0, _classCallCheck3.default)(this, Tab);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Tab).apply(this, arguments));
  }

  (0, _createClass3.default)(Tab, [{
    key: 'handleClick',
    value: function handleClick(index, e) {
      e.preventDefault();
      var tabs = this.context.tabs;
      if (!('activeKey' in this.props)) {
        tabs.setState({ activeIndex: index });
      }
      tabs.props.onChange && tabs.props.onChange(index, this.props.activeKey);
    }
  }, {
    key: 'handleClose',
    value: function handleClose(index, e) {
      e.preventDefault();
      e.stopPropagation();
      var _handleClose = this.context.tabs.props.handleClose;
      _handleClose && _handleClose(index, this.props.activeKey);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var className = _props.className;
      var activeKey = _props.activeKey;
      var abolishClose = _props.abolishClose;
      var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'activeKey', 'abolishClose']);
      var tabs = this.context.tabs;

      var index = tabs.tabCount++;

      'activeKey' in tabs.props && (0, _invariant2.default)('activeKey' in this.props, 'You set `activeKey` for Tabs but no `activeKey` for Tab');

      var isActive = undefined;
      if ('activeKey' in this.props) {
        isActive = activeKey === tabs.props.activeKey;
      } else {
        isActive = index === tabs.state.activeIndex;
      }
      return _react2.default.createElement(
        'li',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-tabs__tab', {
            'bfd-tabs__tab--active': isActive
          }, className) }, other),
        _react2.default.createElement(
          'a',
          { href: '', onClick: this.handleClick.bind(this, index) },
          _react2.default.createElement(
            'span',
            { className: 'bfd-tabs__tab-content' },
            children
          ),
          tabs.props.dynamic && !abolishClose && _react2.default.createElement(_Button2.default, {
            transparent: true,
            icon: 'remove',
            size: 'sm',
            className: 'bfd-tabs__tab-remove',
            onClick: this.handleClose.bind(this, index)
          })
        )
      );
    }
  }]);
  return Tab;
})(_react.Component);

Tab.contextTypes = {
  tabs: _react.PropTypes.object
};

Tab.propTypes = {

  // 与 Tabs activeKey 对应
  activeKey: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 当 Tabs 为 dynamic 时，是否取消关闭按钮
  abolishClose: _react.PropTypes.bool
};

exports.default = Tab;