'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Row = (function (_Component) {
  (0, _inherits3.default)(Row, _Component);

  function Row(props) {
    (0, _classCallCheck3.default)(this, Row);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Row).call(this, props));
  }

  (0, _createClass3.default)(Row, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'a',
        {
          id: this.props.id,
          key: this.props.id,
          href: '#',
          onClick: this.handleClick.bind(this),
          onDoubleClick: this.handleDbClick.bind(this),
          onKeyDown: this.handleKeyDown.bind(this),
          onKeyUp: this.handleKeyUp.bind(this),
          className: 'bfd-row' },
        this.props.label
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      e.preventDefault();
      this.props.onClick();
    }
  }, {
    key: 'handleDbClick',
    value: function handleDbClick() {
      this.props.onDoubleClick();
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      e.preventDefault();
      var code = e.keyCode; // code 17->ctrl  16->shift
      if (code == 16) {
        this.props.onKeyDown('isShift', 1);
      } else if (code == 17) {
        this.props.onKeyDown('isCtrl', 1);
      }
    }
  }, {
    key: 'handleKeyUp',
    value: function handleKeyUp(e) {
      e.preventDefault();
      var code = e.keyCode;
      if (code == 16) {
        this.isShift = 0;
        this.props.onKeyUp('isShift', 0);
      } else if (code == 17) {
        this.isCtrl = 0;
        this.props.onKeyUp('isCtrl', 0);
      }
    }
  }]);
  return Row;
})(_react.Component);

var SelectTable = (function (_Component2) {
  (0, _inherits3.default)(SelectTable, _Component2);

  function SelectTable() {
    (0, _classCallCheck3.default)(this, SelectTable);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SelectTable).call(this));

    _this2.isCtrl = 0;
    _this2.isShift = 0;
    _this2.items = {};
    return _this2;
  }

  (0, _createClass3.default)(SelectTable, [{
    key: 'render',
    value: function render() {
      var _this3 = this;

      var rows = [];
      this.props.data.map(function (item, index) {
        rows.push(_react2.default.createElement(Row, {
          key: index,
          id: item.id,
          label: _this3.props.render ? _this3.props.render(item) : item.label,
          ref: item.id,
          onClick: _this3.handleClick.bind(_this3, item),
          onDoubleClick: _this3.handleDbClick.bind(_this3, item),
          onKeyDown: _this3.handleKeyDown.bind(_this3),
          onKeyUp: _this3.handleKeyUp.bind(_this3)
        }));
      });

      return _react2.default.createElement(
        'div',
        { style: { height: this.props.height + 'px' }, className: 'bfd-transfer__bfd-table' },
        _react2.default.createElement(
          'div',
          { className: 'bfd-transfer__list-group bfd-transfer__bfd-table-conent' },
          rows
        )
      );
    }
  }, {
    key: 'getNode',
    value: function getNode(nodes, id) {
      for (var i = 0; i < nodes.length; i++) {
        var node = nodes[i];
        if (node.id == id) {
          return node;
        }
      }
      return null;
    }
  }, {
    key: 'getMaxDT',
    value: function getMaxDT(nodes, currNode) {
      var len = nodes.length;
      var maxNode = { dt: 0 };
      for (var i = 0; i < len; i++) {
        var node = nodes[i];
        if (node.dt > maxNode.dt && node.dt != currNode.dt) {
          maxNode = node;
          continue;
        }
      }
      if (maxNode.dt > 0) {
        return maxNode;
      } else {
        return currNode;
      }
    }
  }, {
    key: 'getScopeEl',
    value: function getScopeEl(lastEl, el) {
      if (lastEl == el) {
        return [el];
      }
      var scopeEl = [];
      var ps = el.previousSibling;
      var ns = el.nextSibling;
      var isFind = 0; // 是否找到lastEl

      if (ps) {
        while (ps) {
          scopeEl.push(ps);
          if (ps.id == lastEl.id) {
            isFind = 1;
            break;
          }
          ps = ps.previousSibling;
        }
      }
      if (!!ns && !isFind) {
        scopeEl = [];
        while (ns) {
          scopeEl.push(ns);
          if (ns.id == lastEl.id) {
            isFind = 1;
            break;
          }
          ns = ns.nextSibling;
        }
      }
      if (isFind) {
        scopeEl.push(el);
      } else {
        scopeEl = [el];
      }
      return scopeEl;
    }
  }, {
    key: 'resetCss',
    value: function resetCss(els) {
      for (var i = 0; i < els.length; i++) {
        var el = els[i];
        var className = el.className || '';
        el.className = className.replace('selected', '').trim();
      }
    }
  }, {
    key: 'setElCheckedCss',
    value: function setElCheckedCss(els, selectedEls) {
      if (!selectedEls) {
        return;
      }
      if (!(selectedEls instanceof Array)) {
        selectedEls = [selectedEls];
      }
      this.resetCss(els); // 恢复初始状态
      for (var i = 0; i < selectedEls.length; i++) {
        var selectedEl = selectedEls[i];
        for (var j = 0; j < els.length; j++) {
          var el = els[j];
          if (selectedEl == el) {
            el.className += ' selected';
            break;
          }
        }
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick(item) {
      var parentNode = _reactDom2.default.findDOMNode(this);
      var els = parentNode.children[0].getElementsByTagName('a');
      var el = this.getNode(els, item.id);
      var dt = new Date().getTime();
      el.dt = dt; //  加时间属性

      if (this.isCtrl) {
        this.items[item.id] = item;
        var className = el.className || '';
        if (className.indexOf('selected') != -1) {
          el.className = className.replace('selected', '').trim();
        } else {
          el.className += ' selected';
        }
      } else if (this.isShift) {
        this.items[item.id] = item;
        var lastEl = this.getMaxDT(els, el); //  上一次点击元素     
        var scopeEls = this.getScopeEl(lastEl, el); //  找到区间元素
        this.setElCheckedCss(els, scopeEls);
        this.items = {};
        for (var i = 0; i < scopeEls.length; i++) {
          var n = scopeEls[i];
          this.items[n.id] = { id: n.id, label: n.innerHTML };
        }
      } else {
        this.items = {};
        this.items[item.id] = item;
        this.setElCheckedCss(els, el);
      }
      var ids = [];
      for (var p in this.items) {
        ids.push(p);
      }
      this.props.onFoucsItem(ids);
    }
  }, {
    key: 'handleDbClick',
    value: function handleDbClick(item) {
      this.props.onFoucsItem(item.id);
      this.props.onTransfer(this.props.direct);
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(key, value) {
      this[key] = value;
    }
  }, {
    key: 'handleKeyUp',
    value: function handleKeyUp(key, value) {
      this[key] = value;
      if (key == 'isShift') {
        var parentNode = _reactDom2.default.findDOMNode(this);
        var els = parentNode.children[0].getElementsByTagName('a');
        for (var i = 0; i < els.length; i++) {
          var el = els[i];
          delete el.dt;
        }
      }
    }
  }]);
  return SelectTable;
})(_react.Component);

exports.default = SelectTable;