'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Fetch = require('../Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

var _getPathData = require('./getPathData');

var _getPathData2 = _interopRequireDefault(_getPathData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var TreeNode = (function (_Component) {
  (0, _inherits3.default)(TreeNode, _Component);

  function TreeNode() {
    (0, _classCallCheck3.default)(this, TreeNode);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TreeNode).apply(this, arguments));
  }

  (0, _createClass3.default)(TreeNode, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.prepareActivePath(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.prepareActivePath(nextProps);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return this.props.data !== nextProps.data;
    }
  }, {
    key: 'prepareActivePath',
    value: function prepareActivePath(props) {
      props.data.active && props.onActive(props.path);
    }
  }, {
    key: 'changeBySingleProp',
    value: function changeBySingleProp(key, value) {
      this.props.onSinglePropChange(key, value, this.props.path);
    }
  }, {
    key: 'handleToggle',
    value: function handleToggle(e) {
      e.stopPropagation();
      this.changeBySingleProp('open', !this.props.data.open);
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect() {
      this.props.onSelect(this.props.path);
    }
  }, {
    key: 'handleLoad',
    value: function handleLoad(data) {
      var filter = this.props.dataFilter;
      if (filter) {
        data = filter(data);
      }
      this.changeBySingleProp('children', data);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var data = _props.data;
      var path = _props.path;
      var treeData = _props.treeData;
      var contentRender = _props.contentRender;
      var getUrl = _props.getUrl;
      var noDataContent = _props.noDataContent;
      var getIcon = _props.getIcon;
      var beforeRender = _props.beforeRender;
      var shouldSelectable = _props.shouldSelectable;

      var hasChildren = data.children && data.children.length;
      var typeIcon = getIcon && getIcon(data);
      var selectable = shouldSelectable ? shouldSelectable(data, path) : true;

      var Children = undefined,
          List = undefined;
      if (hasChildren) {
        List = _react2.default.createElement(
          'ul',
          { className: 'bfd-tree__node-list' },
          data.children.map(function (item, i) {
            return _react2.default.createElement(TreeNode, (0, _extends3.default)({
              key: i
            }, _this2.props, {
              data: item,
              path: [].concat((0, _toConsumableArray3.default)(path), ['children', i])
            }));
          })
        );
      }

      if (data.isParent) {
        Children = _react2.default.createElement(
          _Fetch2.default,
          {
            className: 'bfd-tree__fetch',
            defaultHeight: 30,
            spinnerHeight: 20,
            url: data.open && getUrl && getUrl(data, (0, _getPathData2.default)(path, treeData)) || '',
            onSuccess: this.handleLoad.bind(this)
          },
          List || _react2.default.createElement(
            'div',
            { className: 'bfd-tree__node--empty' },
            noDataContent
          )
        );
      } else {
        Children = List;
      }

      return _react2.default.createElement(
        'li',
        { className: (0, _classnames2.default)('bfd-tree__node', { 'bfd-tree__node--open': data.open }) },
        _react2.default.createElement(_Button2.default, {
          className: 'bfd-tree__node-toggle',
          style: { visibility: hasChildren || data.isParent ? 'visible' : 'hidden' },
          icon: 'caret-right',
          size: 'sm',
          transparent: true,
          onClick: this.handleToggle.bind(this)
        }),
        beforeRender && _react2.default.createElement(
          'div',
          { className: 'bfd-tree__node-before' },
          beforeRender(data, path)
        ),
        typeIcon && _react2.default.createElement(_Icon2.default, { type: typeIcon, className: 'bfd-tree__node-type' }),
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)('bfd-tree__node-content', {
              'bfd-tree__node-content--active': data.active,
              'bfd-tree__node-content--disabled': !selectable
            }),
            onClick: selectable && this.handleSelect.bind(this)
          },
          contentRender ? contentRender(data, path) : data.name
        ),
        Children
      );
    }
  }]);
  return TreeNode;
})(_react.Component);

exports.default = TreeNode;